SLASH_FARMCOUNT1, SLASH_FARMCOUNT2 = '/farmcount', '/farmcount2'

-- FRAMES
local Loot_Notifier_Event = CreateFrame("Frame")	
local Money_Notifier_Event = CreateFrame("Frame")	
local Honor_Notifier_Event = CreateFrame("Frame")
local Currency_Notifier_Event = CreateFrame("Frame")	
local Reputation_Notifier_Event = CreateFrame("Frame")
local ArtifactPower_Notifier_Event = CreateFrame("Frame")

-- VARIABLE INITIALIZATION
FC_ENABLED = true
FC_lootCountArray = {}
FC_FILTER_LOW_QUALITY_LOOT = true
FC_CLOCK = GetTime()
FC_LASTNOTIFACTION = GetTime()
FC_SESSIONTIMENOTIFICATIONFREQUENCYINMINUTES = 1
FC_GOLD = 0
FC_SILVER = 0
FC_COPPER = 0
FC_HONOR = 0
FC_CurrencyCountArray = {}
FC_ReputationCountArray = {}
aU = C_ArtifactUI
FC_ArtifactPowerCountArray = {}
local name, addon = ...
local LAD = LibStub("LibArtifactData-1.0")

-- HELPER FUNCTIONS -----------------------------------------------------------
function addon:ARTIFACT_ADDED(message, artifactID)
    local id, data = LAD:GetArtifactInfo(artifactID)
	local artifactPower = LAD:GetAcquiredArtifactPower(artifactID)
	
	if FC_ArtifactPowerCountArray[data.name] == nil then
		FC_ArtifactPowerCountArray[data.name] = {}
		FC_ArtifactPowerCountArray[data.name]["id"] = artifactID
		FC_ArtifactPowerCountArray[data.name]["artifactPower"] = artifactPower
	end
	FC_ArtifactPowerCountArrayBeforeReset = FC_ArtifactPowerCountArray
end
function sessionTimeNotification()
	timeElaspedInMinutes = (GetTime()-FC_LASTNOTIFACTION)/60
	if timeElaspedInMinutes > FC_SESSIONTIMENOTIFICATIONFREQUENCYINMINUTES then
		print("\124cffFF0000\124hSession time: "..getFormatedTime(GetTime() - FC_CLOCK))
		FC_LASTNOTIFACTION = GetTime()
	end
end
function getCommaValue(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end
function getWholeNum(num)
	return floor(num)
end
function getFormatedTime(seconds)
	local string = ""
	calcHours = getWholeNum(seconds/3600)
	calcMinutes = floor(60*((seconds/3600)-floor((seconds/3600))))
	calcSeconds = getWholeNum((60*((seconds/3600)-floor((seconds/3600)))-calcMinutes)*60)
	
	
	if calcHours < 2 then
		hoursWord = "Hour"
	else
		hoursWord = "Hours"
	end
	if calcMinutes < 2 then
		minutesWord = "Minute"
	else
		minutesWord = "Minutes"
	end
	if calcSeconds < 2 then
		secondWord = "Second"
	else
		secondWord = "Seconds"
	end
	
	if calcHours > 0 then
		string = calcHours.." "..hoursWord.." "..calcMinutes.." "..minutesWord.." "..calcSeconds.." "..secondWord
	elseif calcMinutes > 0 then
		string = calcMinutes.." "..minutesWord.." "..calcSeconds.." "..secondWord
	else
		string = calcSeconds.." "..secondWord
	end
	
	
	return string
end
function getElapsedTime()
	elapse = getFormatedTime(GetTime() - FC_CLOCK)
	return(elapse)
end
function getFormatedMoney()
	local tGold,tSilver,tCopper
	
	tCopper = FC_COPPER
	tSilver = FC_SILVER
	tGold = FC_GOLD
	
	if FC_COPPER/100 > 1 then
		tSilver = FC_SILVER+floor(FC_COPPER/100)
		tCopper =  string.format("%d",FC_COPPER/100%1*100)
	end
	if tSilver/100 > 1 then
		tGold = FC_GOLD + floor(FC_SILVER/100)
		tSilver = string.format("%d",FC_SILVER/100%1*100)
	end
	
	mphGold = 0
	mphSilver = 0
	mphCopper = 0
	
	convertedToCopper = tGold*100*100+tSilver*100+tCopper
	moneyPerHour = convertedToCopper/((GetTime()-FC_CLOCK)/3600)
	moneyPer = moneyPerHour
	if moneyPerHour < 1 then
		moneyPerMinute = (convertedToCopper/(GetTime()-FC_CLOCK))*60*60
		moneyPer = moneyPerMinute
	end
	
	if moneyPer > 100 then
		mphSilver = floor(moneyPer/100)
		mphCopper = floor(mphCopper/100%1*100)
	end
	if mphSilver > 100 then
		mphGold = floor(mphSilver/100)
		mphSilver = floor(mphSilver/100%1*100)
	end
	
	
	return getCommaValue(tGold).." Gold, "..tSilver.." Silver, "..tCopper.." Copper ("..getCommaValue(mphGold).." Gold "..mphSilver.." Silver "..mphCopper.." Copper per hour)"
end
-- END HELPER FUNCTIONS -------------------------------------------------------

-- COMMANDS
SlashCmd = function(msg)
	if msg == "" then
		print("/farmcount list - list all records")
		print("/farmcount enable - start counting")
		print("/farmcount disable - stop counting")
		print("/farmcount reset - purge all records and reset the start the timer")
		print("/farmcount filter - toggle do not record junk items")
	end
	if msg == "list" then
		print("\124cffFF0000\124h--- Totals for this session (Session Time: " ..getFormatedTime(GetTime() - FC_CLOCK)..") ---")
		
		
		print("\124cffffff00\124hMoney Acquired: "..getFormatedMoney())
		
		-- loot
		print("\124cffFF00D4\124h-- Loot Acquired")
		tempArray = FC_lootCountArray
		iteration = 0
		
		for k,v in pairs(tempArray) do
			lootsPerHour = v["count"]/((GetTime()-FC_CLOCK)/3600)
			lootsPer = string.format("%0.2f",lootsPerHour).." per hour"
			if lootsPerHour < 1 then
				lootsPerMinute = (v["count"]/(GetTime()-FC_CLOCK))*60*60
				lootsPer = string.format("%0.2f",lootsPerMinute).." per hour"
			end
			print(v["name"]..' x '..getCommaValue(v["count"]).." ("..getCommaValue(lootsPer)..")")
			iteration = iteration+1
		end
		if iteration == 0 then
			print("No records of you getting loot.")
		end
		-- Honor
		print("\124cffFF00D4\124h--- Honor Acquired")
		curPerHour = FC_HONOR/((GetTime()-FC_CLOCK)/3600)
		if FC_HONOR == 0 then print("No record of awarded honor.") else
			print(getCommaValue(FC_HONOR).." ("..string.format("%0.2f",curPerHour).." per hour).")
		end
		
		-- currency
		print("\124cffFF00D4\124h--- Currency Acquired")
		tempArray = FC_CurrencyCountArray
		iteration = 0
		for k,v in pairs(tempArray) do
			curPerHour = v/((GetTime()-FC_CLOCK)/3600)
			curPer = string.format("%0.2f",curPerHour).." per hour"
			if curPerHour < 1 then
				curPerMinute = (v/(GetTime()-FC_CLOCK))*60*60
				curPer = string.format("%0.2f",curPerMinute).." per hour"
			end
			print(k..' x '..getCommaValue(v).." ("..getCommaValue(curPer)..")")
			iteration = iteration+1
		end
		if iteration == 0 then
			print("No records of you getting currency.")
		end
		-- artifact power
		print("\124cffFF00D4\124h-- Artifact Power Applied")
		data = LAD:GetAllArtifactsInfo()
		iteration = 0
		for k,v in pairs(data) do
			validate = string.find(k,'[a-z]')
				if validate == nil then
				artifactID = k
				--print('ID:'..artifactID)
				artifactName = v.name
				--print('NAME:'..artifactName)
				--print(FC_ArtifactPowerCountArray[artifactName][id])
				if FC_ArtifactPowerCountArray[artifactName]["id"] == nil then
					--print('Adding new artifact to list: '.. artifactName)
					FC_ArtifactPowerCountArray[artifactName] = {}
					FC_ArtifactPowerCountArray[artifactName]["id"] = artifactID
					FC_ArtifactPowerCountArray[artifactName]["artifactPower"] = LAD:GetAcquiredArtifactPower(artifactID)
				end
				
				artifactPowerGained = LAD:GetAcquiredArtifactPower(artifactID)-FC_ArtifactPowerCountArray[artifactName]["artifactPower"]
				if artifactPowerGained > 0 then
					APPerHour = artifactPowerGained/((GetTime()-FC_CLOCK)/3600)
					APPer = string.format("%0.2f",APPerHour).." per hour"
					if APPerHour < 1 then
						APPerMinute = (artifactPowerGained/(GetTime()-FC_CLOCK))*60*60
						APPer = string.format("%0.2f",APPerMinute).." per hour"
					end
				
				
					print("\124cffFF5400\124h"..artifactName.." gained "..getCommaValue(artifactPowerGained).." ("..getCommaValue(APPer)..")")
					iteration = iteration+1
				end
			end
		end
		if iteration == 0 then
			print("No records of you applying artifact power.")
		end
		-- reputation
		print("\124cffFF00D4\124h-- Reputation Acquired")
		tempArray = FC_ReputationCountArray
		iteration = 0
		for k,v in pairs(tempArray) do
			repPerHour = v/((GetTime()-FC_CLOCK)/3600)
			repPer = string.format("%0.2f",repPerHour).." per hour"
			if repPerHour < 1 then
				repPerMinute = (v/(GetTime()-FC_CLOCK))*60*60
				repPer = string.format("%0.2f",repPerMinute).." per hour"
			end
			print(k..' x '..getCommaValue(v).." ("..getCommaValue(repPer)..")")
			iteration = iteration+1
		end
		if iteration == 0 then
			print("No records of you gaining reputation.")
		end
	end
	if msg == "reset" then
		FC_CLOCK = GetTime()
		local newArray = {}
		local newArray2 = {}
		local  newArray3 = {}
		FC_lootCountArray = newArray
		FC_ReputationCountArray = newArray2
		FC_CurrencyCountArray = newArray3
		FC_GOLD = 0
		FC_SILVER = 0
		FC_COPPER = 0
		FC_HONOR = 0
		
		print("\124cffFF00D4\124hLoot records flushed. New session has started.")
	end
	if msg == "disable" or msg == "off" or msg == "stop" then
		FC_ENABLED = false
		print("\124cffFF00D4\124hFarmCount disabled.")
	end
	if msg == "enable" or msg == "on" or msg == "start" then
		FC_ENABLED = true
		print("\124cffFF00D4\124hFarmCount enabled.")
	end
	if msg == "filter" then
		if FC_FILTER_LOW_QUALITY_LOOT == true then
			FC_FILTER_LOW_QUALITY_LOOT = false
			print("\124cffFF00D4\124hLow quality loot filter disabled")
		elseif FC_FILTER_LOW_QUALITY_LOOT == false then
			FC_FILTER_LOW_QUALITY_LOOT = true
			print("\124cffFF00D4\124hLow quality loot filter enabled")
		end
	end
	if msg == "time" then
		FC_CLOCK = FC_CLOCK-5400
	end
		
end
SlashCmdList["FARMCOUNT"] = SlashCmd

-- CALLBACK REGISTERATIONS
LAD.RegisterCallback(addon, "ARTIFACT_ADDED")

-- EVENT HANDLERS -------------------------------------------------------------

-- ARTIFACT POWER EVENT
ArtifactPower_Notifier_Event:RegisterEvent("ARTIFACT_XP_UPDATE")
ArtifactPower_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
	if FC_ENABLED == false then return end
end)

-- REPUTATION EVENT
Reputation_Notifier_Event:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
Reputation_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
	if FC_ENABLED == false then return end
	
	local arg1, arg2 = ...
	--print("Farmcount identified currency event")
	eventMessage = string.match(arg1, "(.*)")
	
	itemFaction, itemValue = string.match(arg1 , "Reputation with (.*) increased by (.*)\.")
	
	if FC_ReputationCountArray[itemFaction] == nil then
		FC_ReputationCountArray[itemFaction] = 0
	end
	FC_ReputationCountArray[itemFaction] = FC_ReputationCountArray[itemFaction]+itemValue
	
	repPerHour = FC_ReputationCountArray[itemFaction]/((GetTime()-FC_CLOCK)/3600)
	repPer = string.format("%0.2f",repPerHour).." per hour"
	if repPerHour < 1 then
		repPerMinute = (FC_ReputationCountArray[itemFaction]/(GetTime()-FC_CLOCK))*60*60
		repPer = string.format("%0.2f",repPerMinute).." per hour"
	end
	print(getCommaValue(FC_ReputationCountArray[itemFaction]) .."x "..itemFaction.." reputation acquired this session. ("..getCommaValue(repPer)..")")
	sessionTimeNotification() 
end)

-- HONOR EVENT
Honor_Notifier_Event:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN")
Honor_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
	if FC_ENABLED == false then return end

	local arg1, arg2 = ...
    honor = string.match(arg1, "You have been awarded (.*) Honor\.");
	
	
	FC_HONOR = FC_HONOR+honor
	honorPerHour = FC_HONOR/((GetTime()-FC_CLOCK)/3600)
	repPer = string.format("%0.2f",honorPerHour).." per hour"
	
	print(getCommaValue(FC_HONOR).." Honor acquired this session. ("..getCommaValue(repPer).." per hour)")
	sessionTimeNotification() 
end)

-- CURRENCY EVENT
Currency_Notifier_Event:RegisterEvent("CHAT_MSG_CURRENCY")
Currency_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
	if FC_ENABLED == false then return end
	
	local arg1, arg2 = ...

	eventMessage = string.match(arg1, "(.*)")
	
	itemValueString = string.match(arg1 , "You receive currency: (.*)\.")
	itemName = string.match(itemValueString,"(.*)x%d+")
	if itemName == nil then
		itemName = string.match(itemValueString,"(.*)")
	end
	
	itemValue = string.match(itemValueString,".*x(%d+)")
	if FC_CurrencyCountArray[itemName] == nil then
		FC_CurrencyCountArray[itemName] = 0
	end
	FC_CurrencyCountArray[itemName] = FC_CurrencyCountArray[itemName]+itemValue
	curPerHour = FC_CurrencyCountArray[itemName]/((GetTime()-FC_CLOCK)/3600)
	curPer = string.format("%0.2f",curPerHour).." per hour"
	if curPerHour < 1 then
		curPerMinute = (FC_CurrencyCountArray[itemName]/(GetTime()-FC_CLOCK))*60*60
		curPer = string.format("%0.2f",curPerMinute).." per hour"
	end

	print(getCommaValue(FC_CurrencyCountArray[itemName]) .."x "..itemName.." acquired this session. ("..getCommaValue(curPer)..")")
	sessionTimeNotification() 
end)

-- MONEY EVENT
Money_Notifier_Event:RegisterEvent("CHAT_MSG_MONEY")
Money_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
	local arg1, arg2 = ...
	
	if FC_ENABLED == false then return end

	tempGold = string.match(arg1, "([0-9]*) Gold")
	if tempGold ~= nil then FC_GOLD = FC_GOLD+tempGold else tempGold = 0 end
	
	tempSilver = string.match(arg1, "([0-9]*) Silver")
	if tempSilver ~= nil then FC_SILVER = FC_SILVER+tempSilver else tempSilver = 0 end
	
	tempCopper = string.match(arg1, "([0-9]*) Copper")
	if tempCopper ~= nil then FC_COPPER = FC_COPPER+tempCopper else tempCopper = 0 end
	
	mphGold = 0
	mphSilver = 0
	mphCopper = 0
	
	convertedToCopper = tempGold*100*100+tempSilver*100+tempCopper
	moneyPerHour = convertedToCopper/((GetTime()-FC_CLOCK)/3600)
	moneyPer = moneyPerHour
	if moneyPerHour < 1 then
		moneyPerMinute = (convertedToCopper/(GetTime()-FC_CLOCK))*60*60
		moneyPer = moneyPerMinute
	end
	
	if moneyPer > 100 then
		mphSilver = floor(moneyPer/100)
		mphCopper = mphCopper/100%1*100
	end
	if mphSilver > 100 then
		mphGold = floor(mphSilver/100)
		mphSilver = mphSilver/100%1*100
	end
	
	eventMessage = string.match(arg1, "(.*)("..getCommaValue(mphGold).." Gold "..mphSilver.." Silver "..mphCopper.." Copper per hour)")

	print(getFormatedMoney().." looted this session.")
	sessionTimeNotification() 
end)

-- LOOT EVENT
Loot_Notifier_Event:RegisterEvent("CHAT_MSG_LOOT")
Loot_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
		if FC_ENABLED == false then return end
		
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 = ...
		
		itemName, itemAmount = string.match(arg1 , "You receive loot: (.*)\.")
		if itemName == nil then
			itemName, itemAmount = string.match(arg1 , "You receive item: (.*)\.")
		end

		if itemName ~= nil then
			name = string.match(itemName, "(.*)x%d+")
			if name == nil then
				name = string.match(itemName, "(.*)")
			end
			
			amount = string.match(itemName, ".*x(%d+)")
			if amount ~= nil then
			elseif name ~= nil then
				amount = 1
			else
				print("FC loot name or amount error skipped.....")
				return
			end
			--if FC_ENABLED == true then
				name,link,qualityRating,iLevel,a4,a5,subClass,a7,a8 = GetItemInfo(itemName)
				id = link:match("item:(%d+):")
				if qualityRating == 0 and FC_FILTER_LOW_QUALITY_LOOT == true then
					return
				else
					if FC_lootCountArray[id] == nil then
						FC_lootCountArray[id] = {}
						FC_lootCountArray[id]["count"] = 0
						FC_lootCountArray[id]["name"] = link
					end
					
					FC_lootCountArray[id]["count"] = FC_lootCountArray[id]["count"]+amount
					
					lootsPerHour = FC_lootCountArray[id]["count"]/((GetTime()-FC_CLOCK)/3600)
					lootsPer = string.format("%0.2f",lootsPerHour).." per hour"
					if lootsPerHour < 1 then
						lootsPerMinute = (FC_lootCountArray[id]["count"]/(GetTime()-FC_CLOCK))*60*60
						lootsPer = string.format("%0.2f",lootsPerMinute).." per hour"
					end
					print(getCommaValue(FC_lootCountArray[id]["count"]).." "..link.." collected this session. ("..getCommaValue(lootsPer)..")")
					sessionTimeNotification() 
				end
			--end
		end
end)

-- END EVENT HANDLERS ---------------------------------------------------------

